"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _lodash = _interopRequireDefault(require("lodash/"));
var _utilities = require("./../utilities");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
var _default = function _default(context) {
  var report = function report(node) {
    context.report({
      loc: node.loc,
      message: 'Duplicate property.',
      node: node
    });
  };
  var checkForDuplicates = function checkForDuplicates(node) {
    var haystack = [];
    _lodash["default"].forEach(node.properties, function (identifierNode) {
      var needle = (0, _utilities.getParameterName)(identifierNode, context);
      if (_lodash["default"].includes(haystack, needle)) {
        report(identifierNode);
      } else {
        haystack.push(needle);
      }
    });
  };
  return {
    ObjectTypeAnnotation: checkForDuplicates
  };
};
exports["default"] = _default;