"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _lodash = _interopRequireDefault(require("lodash"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
var reportWeakType = function reportWeakType(context, weakType) {
  return function (node) {
    context.report({
      data: {
        weakType: weakType
      },
      message: 'Unexpected use of weak type "{{weakType}}"',
      node: node
    });
  };
};
var genericTypeEvaluator = function genericTypeEvaluator(context, _ref) {
  var checkFunction = _ref.checkFunction,
    checkObject = _ref.checkObject;
  return function (node) {
    var name = _lodash["default"].get(node, 'id.name');
    if (checkFunction && name === 'Function' || checkObject && name === 'Object') {
      reportWeakType(context, name)(node);
    }
  };
};
var _default = function _default(context) {
  var checkAny = _lodash["default"].get(context, 'options[0].any', true) === true;
  var checkFunction = _lodash["default"].get(context, 'options[0].Function', true) === true;
  var checkObject = _lodash["default"].get(context, 'options[0].Object', true) === true;
  var checks = {};
  if (checkAny) {
    checks.AnyTypeAnnotation = reportWeakType(context, 'any');
  }
  if (checkFunction || checkObject) {
    checks.GenericTypeAnnotation = genericTypeEvaluator(context, {
      checkFunction: checkFunction,
      checkObject: checkObject
    });
  }
  return checks;
};
exports["default"] = _default;