"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _lodash = _interopRequireDefault(require("lodash"));
var _utilities = require("./../utilities");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
var _default = (0, _utilities.iterateFunctionNodes)(function (context) {
  return function (functionNode) {
    _lodash["default"].forEach(functionNode.params, function (identifierNode) {
      var nodeType = _lodash["default"].get(identifierNode, 'type');
      var isAssignmentPattern = nodeType === 'AssignmentPattern';
      var hasTypeAnnotation = Boolean(_lodash["default"].get(identifierNode, 'typeAnnotation'));
      var leftAnnotated = Boolean(_lodash["default"].get(identifierNode, 'left.typeAnnotation'));
      if (isAssignmentPattern && hasTypeAnnotation && !leftAnnotated) {
        context.report({
          data: {
            name: (0, _utilities.quoteName)((0, _utilities.getParameterName)(identifierNode, context))
          },
          message: '{{name}}parameter type annotation must be placed on left-hand side of assignment.',
          node: identifierNode
        });
      }
    });
  };
});
exports["default"] = _default;