"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _lodash = _interopRequireDefault(require("lodash"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
var _default = function _default(identifierNode, context) {
  if (_lodash["default"].has(identifierNode, 'name')) {
    return identifierNode.name;
  }
  if (_lodash["default"].has(identifierNode, 'left.name')) {
    return identifierNode.left.name;
  }
  if (_lodash["default"].has(identifierNode, 'key.name')) {
    return identifierNode.key.name;
  }
  if (identifierNode.type === 'RestElement') {
    return identifierNode.argument.name;
  }
  if (identifierNode.type === 'ObjectTypeProperty') {
    var tokenIndex = 0; // eslint-disable-line init-declarations

    if (identifierNode["static"]) {
      tokenIndex++;
    }
    if (identifierNode.variance) {
      tokenIndex++;
    }
    return context.getSourceCode().getFirstToken(identifierNode, tokenIndex).value;
  }
  if (identifierNode.type === 'FunctionTypeParam') {
    return context.getSourceCode().getFirstToken(identifierNode).value;
  }
  if (identifierNode.type === 'ObjectPattern' || identifierNode.type === 'ArrayPattern') {
    var text = context.getSourceCode().getText(identifierNode);
    if (identifierNode.typeAnnotation) {
      return text.replace(context.getSourceCode().getText(identifierNode.typeAnnotation), '').trim();
    } else {
      return text;
    }
  }
  if (_lodash["default"].get(identifierNode, 'left.type') === 'ObjectPattern') {
    return context.getSourceCode().getText(identifierNode.left);
  }
  return null;
};
exports["default"] = _default;