"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.stripSpacesBefore = exports.stripSpacesAfter = exports.stripSpaces = exports.addSpaceBefore = exports.addSpaceAfter = exports.addSpace = void 0;
var stripSpacesBefore = function stripSpacesBefore(node, spaces) {
  return function (fixer) {
    return fixer.removeRange([node.start - spaces, node.start]);
  };
};
exports.stripSpacesBefore = stripSpacesBefore;
var stripSpacesAfter = function stripSpacesAfter(node, spaces) {
  return function (fixer) {
    return fixer.removeRange([node.end, node.end + spaces]);
  };
};
exports.stripSpacesAfter = stripSpacesAfter;
var addSpaceBefore = function addSpaceBefore(node) {
  return function (fixer) {
    return fixer.insertTextBefore(node, ' ');
  };
};
exports.addSpaceBefore = addSpaceBefore;
var addSpaceAfter = function addSpaceAfter(node) {
  return function (fixer) {
    return fixer.insertTextAfter(node, ' ');
  };
};
exports.addSpaceAfter = addSpaceAfter;
var stripSpaces = function stripSpaces(direction, node, spaces) {
  if (direction === 'before') {
    return stripSpacesBefore(node, spaces);
  } else {
    return stripSpacesAfter(node, spaces);
  }
};
exports.stripSpaces = stripSpaces;
var addSpace = function addSpace(direction, node) {
  if (direction === 'before') {
    return addSpaceBefore(node);
  } else {
    return addSpaceAfter(node);
  }
};
exports.addSpace = addSpace;